#include <Arduino.h>
#include <stdio.h>
#include <stdlib.h>
#include "driver/i2s.h" // Library of I2S routines, comes with ESP32 standard install
#include "Bruins_Goal_Horn.h"
#include "Sad_Trambone.h"
#include "Sonic_Ring.h"
#include "Curb_Loser.h"

#define USE_I2S_SPEAKER_OUTPUT
#define I2S_SPEAKER_SERIAL_DATA GPIO_NUM_4
#define I2S_SPEAKER_SERIAL_CLOCK GPIO_NUM_16
#define I2S_SPEAKER_LEFT_RIGHT_CLOCK GPIO_NUM_17

static i2s_port_t i2s_num = I2S_NUM_0; // i2s port number


struct WavHeader_Struct
{
    //   RIFF Section
    char RIFFSectionID[4]; // Letters "RIFF"
    uint32_t Size;         // Size of entire file less 8
    char RiffFormat[4];    // Letters "WAVE"

    //   Format Section
    char FormatSectionID[3]; // letters "fmt"
    uint32_t FormatSize;     // Size of format section less 8
    uint16_t FormatID;       // 1=uncompressed PCM
    uint16_t NumChannels;    // 1=mono,2=stereo
    uint32_t SampleRate;     // 44100, 16000, 8000 etc.
    uint32_t ByteRate;       // =SampleRate * Channels * (BitsPerSample/8)
    uint16_t BlockAlign;     // =Channels * (BitsPerSample/8), effectivly the size of a single sample for all chans.
    uint16_t BitsPerSample;  // 8,16,24 or 32

    // Data Section
    char DataSectionID[4]; // The letters "data"
    uint32_t DataSize;     // Size of the data that follows
};

// speaker settings


// Shutdown line if you have this wired up or -1 if you don't
#define I2S_SPEAKER_SD_PIN -1



//    HEADERS    //

bool validWAVData(WavHeader_Struct *Wav);
void dumpWAVHeader(WavHeader_Struct *Wav);
void play(const unsigned char *WavFile);

//    FUNCTION DEFINITIONS    //

bool validWAVData(WavHeader_Struct *Wav);
void dumpWAVHeader(WavHeader_Struct *Wav);
void play(const unsigned char *WavFile);